program Lide;

{%ToDo 'Lide.todo'}

uses
  Windows,
  Messages,
  OpenGL,
  e_system in 'e_system.pas',
  e_global in 'e_global.pas',
  e_screen in 'e_screen.pas',
  e_font in 'e_font.pas',
  e_main in 'e_main.pas',
  e_types in 'e_types.pas',
  e_sound in 'e_sound.pas',
  e_utils in 'e_utils.pas',
  e_render in 'e_render.pas',
  e_models in 'e_models.pas',
  e_textures in 'e_textures.pas',
  e_particles in 'e_particles.pas',
  e_about in 'e_about.pas',
  e_game in 'e_game.pas',
  e_camera in 'e_camera.pas',
  e_player in 'e_player.pas',
  e_console in 'e_console.pas',
  e_console_commands in 'e_console_commands.pas',
  e_weapons in 'e_weapons.pas',
  e_enemies in 'e_enemies.pas',
  e_menu in 'e_menu.pas',
  e_towers in 'e_towers.pas',
  e_lines in 'e_lines.pas',
  e_level0 in 'e_level0.pas',
  e_level1 in 'e_level1.pas',
  e_level2 in 'e_level2.pas',
  e_level3 in 'e_level3.pas',
  e_level4 in 'e_level4.pas',
  e_level5 in 'e_level5.pas',
  e_level6 in 'e_level6.pas';

var
  msg  : TMSG;
  wTime, wTime_Delta,
  ups_delta, ups_time_old : DWORD;
  game_loaded : boolean = false;
  
{$R *.res}

begin
ConsoleInitialization;

if not ProgramInitialization then exit;

ups_delta    := 25;
ups_time_old := GetTimer - ups_delta;
//ups_time     := GetTimer;


e_main.Initialize;
Console.Write('Initialized');
Console.Write('');

while not quit do
  begin
    while PeekMessage(msg, 0, 0, 0, PM_REMOVE) do
      begin               
        if msg.message = wm_quit then quit := true;
        TranslateMessage(msg);
        DispatchMessage(msg);
      end;

    wTime       := GetTimer;
    wTime_Delta := wTime - ups_time_old;
    while wTime_Delta >= ups_delta do
      begin
        if game_loaded then
          e_main.Update(ups_delta);
        dec(wTime_Delta, ups_delta);
      end;
    ups_time_old := wTime - wTime_Delta;

    game_loaded := true;
    e_main.Render;
  end;
e_main.Deinitialize;
ProgramDeInitialization;
Console.Write('Quit');

end.
