unit e_render;

interface

uses Windows, OpenGL, e_global, e_screen, e_utils, e_font, e_game, e_camera,
     e_models, e_textures, e_particles, e_types, e_about;

procedure Render;

implementation

uses e_main;

procedure Render;
begin
ViewPerspective(camera);
MoveCamera(camera);

glDisable(GL_LIGHTING);
glEnable(GL_TEXTURE_2D);
glDisable(GL_DEPTH_TEST);

glEnable(GL_BLEND);
glEnable(GL_TEXTURE_2D);

if game_started then
  game.Render;
end;

end.
