  function GetTimer: Integer; inline;
  procedure Log(Mess: string); inline;
  procedure Assert(Cond: Boolean; Mess: string = 'TGame.Assert error'); inline;
  procedure PlaySound(FileName: string); inline;
  procedure PlayMusic(FileName: string); inline;

  function Mouse: TVec2i; inline;
  function GetWidth: Integer; inline;
  function GetHeight: Integer; inline;

  procedure BeginRender; inline;
  procedure Clear(R, G, B: Single; A: Single = 1); inline;
  procedure EndRender; inline;
  procedure SetBlendMode(Mode: TBlendMode); inline;
  function LoadTex(FileName: string): TTexture; inline;
  function CreateSprite: TSprite; inline;
  procedure SetPointSize(Size: Single); inline;
  procedure SetLineWidth(Width: Single); inline;  
  procedure SetTexture(ID: TTexture); inline;
  procedure SetColor(R, G, B, A: Single); inline;
  procedure Color4f(V: TVec4f); inline;  
  procedure DrawLine(A, B: TVec2f); inline;  
  procedure DrawRect(Pos, Size: TVec2f; Fill: Boolean = True); inline;  
  procedure DrawCircle(Pos: TVec2f; Rad: Single; Fill: Boolean = True); inline;
  procedure PushMatrix; inline;
  procedure PopMatrix; inline;
  procedure Translate(V: TVec2f); inline;
  
  function CreateParticle(Flags: Cardinal; 
                          Pos, Dir: TVec2f;
                          Rad: Single;
                          Col: TVec4f;
                          ID: Cardinal): Integer; inline;
  function GetParticle(Index: Integer): TParticle; inline;
  procedure SetParticle(Index: Integer; Particle: TParticle); inline;
  procedure KillParticle(Index: Integer); inline;
