#include "DrawStaff.h"

#include <windows.h>
#include <gl/gl.h>


void drawTexturedQuad(vec2& p, vec2& size, vec4& alpha)
{
	glEnable(GL_TEXTURE_2D);

	glBegin(GL_QUADS);

	glColor4f(1.0f, 1.0f, 1.0f, alpha.x);
	glTexCoord2f(0.0f, 1.0f); glVertex2f(p.x, p.y);

	glColor4f(1.0f, 1.0f, 1.0f, alpha.y);
	glTexCoord2f(1.0f, 1.0f); glVertex2f(p.x + size.x, p.y);

	glColor4f(1.0f, 1.0f, 1.0f, alpha.z);
	glTexCoord2f(1.0f, 0.0f); glVertex2f(p.x + size.x, p.y + size.y);

	glColor4f(1.0f, 1.0f, 1.0f, alpha.w);
	glTexCoord2f(0.0f, 0.0f); glVertex2f(p.x, p.y + size.y);
	glEnd();

	glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
}

void drawQuad ( vec2& p, vec2& size, vec4& color )
{
	glDisable(GL_TEXTURE_2D);

	glColor4fv(color);

	glBegin(GL_QUADS);
	glVertex2f(p.x, p.y);
	glVertex2f(p.x + size.x, p.y);
	glVertex2f(p.x + size.x, p.y + size.y);
	glVertex2f(p.x, p.y + size.y);
	glEnd();

	glColor4f(1.0f, 1.0f, 1.0f, 1.0f);

	glEnable(GL_TEXTURE_2D);
}
